Attribute VB_Name = "modKiller"
Option Explicit
' Dclaration des API utilises
Private Declare Function GetWindowText Lib "user32" Alias "GetWindowTextA" _
        (ByVal hwnd As Long, ByVal lpString As String, ByVal cch As Long) As Long
Private Declare Function EnumWindows Lib "user32" (ByVal lpEnumFunc As Long, _
        ByVal lParam As Long) As Long
Private Declare Function GetWindowRect Lib "user32" (ByVal hwnd As Long, lpRect As RECT) As Long
Public Declare Function PostMessage Lib "user32" Alias "PostMessageA" _
        (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, _
        ByVal lParam As Long) As Long
Public Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, _
        ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long

' Dclaration de type
Private Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type

' Dclaration de constante
Public Const WM_CLOSE = &H10
' Variable temporaire utilise uniquement par la fonction GetWindowsList pour stocker les fentres.
Public stGetWindowsList As String
' Nombre de popup supprimes dbut le lancement
Public lgKill As Long
' Redimensionnement automatique des colonnes du contrle ListView
Public Const LVM_FIRST = &H1000
Public Const LVM_SETCOLUMNWIDTH = LVM_FIRST + 30
Public Const LVSCW_AUTOSIZE = -1

Public Function GetWindowsList()
' Cette fonction retourne sous forme de tableau l'ensemble
' des titres des fentres de premier niveau ouvertes sous windows.
Dim lgRep As Long
stGetWindowsList = vbNullString
' Appel de l'API et envoi du pointeur vers notre fonction de rappel
lgRep = EnumWindows(AddressOf EnumWindowsProc, 0)
' Dcoupage de la chane pour retourner un tableau
GetWindowsList = Split(stGetWindowsList, vbCrLf)
End Function

' Dclaration de la fonction de rappel
Public Function EnumWindowsProc(ByVal lgHwnd As Long, ByVal lgParam As Long) As Long
Dim stTmp As String, lgTmp As Long, lgRet As Long
Dim stTmp2 As String, tmpRect As RECT
stTmp = Space$(201)
lgTmp = 200
' On rcupre le titre de la fentre  partir du handle
lgRet = GetWindowText(lgHwnd, stTmp, lgTmp)
stTmp = Trim$(Replace(stTmp, Chr$(0), vbNullString))
If (stTmp <> vbNullString) Then
    ' Rcupre les dimensions de la fentre
    lgRet = GetWindowRect(lgHwnd, tmpRect)
    ' Ajoute les dimensions de la fentre  la chane retourne
    stTmp = Format$(tmpRect.Right - tmpRect.Left, "00000000") & " " & stTmp
    stTmp = Format$(tmpRect.Bottom - tmpRect.Top, "00000000") & " " & stTmp
End If
If (stTmp <> vbNullString) Then
    stTmp = Format$(lgHwnd, "00000000000;-0000000000") & " " & stTmp
End If
' Stockage du rsultat dans la chaine temporaire (ajout au texte existant).
' On pourrait imaginer construire une chane plus complexe en ajoutant galement le handle
' de la fentre, ce qui permettrait des manipulations externes (comme une fermeture par exemple).
If (Trim$(stTmp) <> vbNullString) Then stGetWindowsList = stGetWindowsList & stTmp & vbCrLf
' Retourne 1 systmatiquement
EnumWindowsProc = 1
End Function

Public Function FileToString(stFile As String) As String
' Lecture d'un fichier et rcupration  l'intrieur d'une chane unique
' Attention, au ralentissement pour les fichiers de taille importante.
' A n'utiliser que sur les fichiers de type texte.
On Error GoTo errFileToString
Dim inFree As Integer
Dim stTmp As String
inFree = FreeFile
Open stFile For Input Shared As #inFree
stTmp = Input(LOF(inFree), #inFree)
Close #inFree
FileToString = stTmp
Exit Function
errFileToString:
FileToString = vbNullString
End Function

Public Function StringToFile(stString As String, stFile As String) As String
' Enregistrement d'une chaine dans un fichier. En cas de russite la fonction retourne une chane vide
' sinon, un message d'erreur.
' Cette fonction est l'inverse de la prcdente
Dim inFree As Integer
Dim stTmp As String
On Error GoTo ErrStringToFile
inFree = FreeFile
Open stFile For Output As #inFree
Print #inFree, stString
Close #inFree
StringToFile = vbNullString
Exit Function
ErrStringToFile:
StringToFile = "Erreur (" & Err.Number & "), " & Err.Description
End Function

Public Function Path(stFile As String) As String
' Cette fonction permet de dfinir un chemin complet pour un nom de fichier
If (Mid$(stFile, 2, 2) <> ":\") And (Left$(stFile, 2) <> "\\") Then
    Path = App.Path & IIf(Right$(App.Path, 1) <> "\", "\", vbNullString) & stFile
Else
    Path = stFile
End If
End Function

Public Function InList(lstListe As ListView, stElement As String, Optional blRespecteCasse As Boolean = True) As Long
' Vrifie la prsence d'un lment dans une liste
Dim lgFor As Long
Dim stLike As String
For lgFor = 1 To lstListe.ListItems.Count
    stLike = Replace(lstListe.ListItems(lgFor).Text, "[", Chr$(1))
    stLike = Replace(stLike, "]", "[]]")
    stLike = Replace(stLike, Chr$(1), "[[]")
    stLike = Replace(stLike, "*", "[*]")
    stLike = "*" & Replace(stLike, "?", "[?]") & "*"
    If blRespecteCasse Then
        If (stElement Like stLike) Then
            InList = lgFor
            Exit Function
        End If
    Else
        If (UCase$(stElement) Like UCase$(stLike)) Then
            InList = lgFor
            Exit Function
        End If
    End If
Next lgFor
InList = -1
End Function

Public Sub AdjustColListView(lvwListView As Object, frmAppel As Form)
Dim lgFor As Long
For lgFor = 0 To lvwListView.ColumnHeaders.Count - 1
' Ajuste la largeur des colonnes  leur contenu
    Call SendMessage(lvwListView.hwnd, LVM_SETCOLUMNWIDTH, lgFor, LVSCW_AUTOSIZE)
' Vrifie que le titre la colonne est toujours visible compltment, sinon, augmente la taille de la colonne
    If lvwListView.ColumnHeaders(lgFor + 1).Width < frmAppel.TextWidth(lvwListView.ColumnHeaders(lgFor + 1).Text) + 180 Then
        lvwListView.ColumnHeaders(lgFor + 1).Width = frmAppel.TextWidth(lvwListView.ColumnHeaders(lgFor + 1).Text) + 180
    End If
Next lgFor
End Sub

Public Sub ListViewColumnClick(lswListView As Object, ColHeadIndex As Long)
' Permet de trier les donnes  l'intrieur des colonnes par ordre croissant ou dcroissant
' lorsque l'on clique sur l'entete.
If ColHeadIndex - 1 = lswListView.SortKey Then
    If lswListView.SortOrder = 0 Then ' lvwAscending
        lswListView.SortOrder = 1 ' lvwDescending
    Else
        lswListView.SortOrder = 0 ' lvwAscending
    End If
Else
    lswListView.SortKey = ColHeadIndex - 1
    lswListView.SortOrder = 0 ' lvwAscending
End If
lswListView.Sorted = True
End Sub

Public Sub SetListViewColumnName(lswListView As Object, ParamArray tabColumn())
' Permet de dfinir les colonnes d'un ListView en une seule ligne...
Dim lgFor As Long
lswListView.ColumnHeaders.Clear
For lgFor = 0 To UBound(tabColumn)
    lswListView.ColumnHeaders.Add , , tabColumn(lgFor)
Next lgFor
End Sub

Public Function KeyPress_0_9_only(KeyAscii As Integer, Optional stPlus As String = vbNullString) As Integer
If InStr("0123456789" & stPlus, Chr$(KeyAscii)) <= 0 And KeyAscii > 31 Then KeyPress_0_9_only = 0 Else KeyPress_0_9_only = KeyAscii
End Function

Public Sub KeyUpDown(txtCall As TextBox, KeyCode As Integer, lgMin As Long, lgMax As Long)
' Augmente ou diminue le nombre de la zone de texte suivant la touche appuye
If (Val(txtCall.Text) < lgMax) Then
    If (KeyCode = vbKeyUp) Then txtCall.Text = Trim$(Str$(Val(txtCall.Text) + 1))
End If
If (Val(txtCall.Text) > lgMin) Then
    If (KeyCode = vbKeyDown) Then txtCall.Text = Trim$(Str$(Val(txtCall.Text) - 1))
End If
End Sub
